package starvation;

import javax.swing.JProgressBar;

public class MyThread extends Thread {

	private int myProgress = 0;
	private MyObject o;
	private JProgressBar bar;
	public MyThread(MyObject o, JProgressBar bar) {
		this.o = o;
		this.bar = bar;
	}
	
	@Override
	public void run() {
//		starvation();
		withoutStarvation();
	}
	
	private void starvation() {
		synchronized(o) {
			while(o.progress < 100) {
				myProgress++;
				o.add();
				bar.setValue(myProgress);				
				try {
					Thread.sleep(300);
				} catch (InterruptedException e) {
					e.printStackTrace();
				}
			}
		}
		System.out.println(myProgress);
	}
	
	private void withoutStarvation() {
		while(true) {
			int progress;
			synchronized(o) {
				progress = o.progress;
			}
			if(progress >= 100)
				break;
			
			synchronized(o) {
				myProgress++;
				o.add();
				bar.setValue(myProgress);
			}
			
			try {
				Thread.sleep(300);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}				
		}
		System.out.println(myProgress);
	}
}
